import java.io.*;
import java.net.*;
import java.util.StringTokenizer;

/**
 * @author Ana Sanz Merino [University of California Berkeley, 2003]
 * @version $Revision: 1.1.1.1 $
 */


public class addIPUrl
{
    private static final int addIpUrlPort = 9002;

    static boolean trace = false;
 
    public static void main(String[] args) throws Exception
    {
	parseTraceArg(args);

	DatagramSocket sock = new DatagramSocket(addIpUrlPort);
	DatagramPacket pack;
        byte[] buff;
        String data;
	StringReader reader;
	LineNumberReader in;

	while (true) {
	    buff = new byte[500];
	    pack = new DatagramPacket(buff, buff.length);
	    sock.receive(pack);
	    data = new String(pack.getData());
	    if (trace) {
                System.out.println("Received data: " + data);
            }
	    reader = new StringReader(data);
	    in = new LineNumberReader(reader);
 
            String ipAddress = in.readLine();
	    String url = in.readLine();
	    if (trace) {
                System.out.println("line1: " + ipAddress);
                System.out.println("line2: " + url);
            }
            StringTokenizer urlSt = new StringTokenizer(url, "//");
            int urlTokens = urlSt.countTokens();
            String aux1 = urlSt.nextToken();
            if (urlTokens > 1) {
                aux1 = urlSt.nextToken();
            }
            StringTokenizer aux1St = new StringTokenizer(aux1, ":");
            int aux1Tokens = aux1St.countTokens();
            String host = aux1St.nextToken();
            String port = "80";
            if (aux1Tokens > 1) {
                aux1 = aux1St.nextToken();
                StringTokenizer portSt = new StringTokenizer(aux1, "/");
                port = portSt.nextToken();
            }

	    if (trace) {
	        System.out.println("IP Address: " + ipAddress);
	        System.out.println("Host: " + host);
	        System.out.println("Port: " + port);
            }

	    String command = "/sbin/iptables -A OUT_NETWORK -s " + ipAddress + " -d " + host + " -p tcp --dport " + port + " -j AUTH_IP";
            Runtime rt = Runtime.getRuntime();
            Process ipTables = rt.exec(command);
            int result = ipTables.waitFor();
            if (result != 0) {
                throw new Exception("Add IP URL failed");
            }

            String command2 = "/sbin/iptables -t nat -I WEB_REDIRECT -s " +  ipAddress + " -d " + host + " -p tcp --dport " +
                                port + " -j RETURN";
            ipTables = rt.exec(command2);
            result = ipTables.waitFor();
            if (result != 0) {
                throw new Exception("Add IP URL failed");
            }
        }
    }


    private static void parseTraceArg(String[] args)
    {
        // The trace argument must be the first one.
        // This is to save execution time
        // If -t is present just after the program name, traces will be output

        if (args.length >= 1)
        {
            if (args[0].equals("-t"))
            {
                trace = true;
            }
        }
    }
}
