import java.io.*;
import java.net.*;
import java.util.StringTokenizer;

/**
 * @author Ana Sanz Merino [University of California Berkeley, 2003]
 * @version $Revision: 1.1.1.1 $
 */


public class removeIPUrl
{
    private static final int removeIpUrlPort = 9003;

    static boolean trace = false;
 
    public static void main(String[] args) throws Exception
    {
	parseTraceArg(args);

        DatagramSocket sock = new DatagramSocket(removeIpUrlPort);
        DatagramPacket pack;
        byte[] buff;
        String data;
        StringReader reader;
        LineNumberReader in;

        while (true) {
            /* Receive information about the entry to remove */
            buff = new byte[500];
            pack = new DatagramPacket(buff, buff.length);
            sock.receive(pack);
            data = new String(pack.getData());
            if (trace) {
                System.out.println("Received data: " + data);
            }
            reader = new StringReader(data);
            in = new LineNumberReader(reader);

            String ipAddress = in.readLine();
	    String url = in.readLine();
	    if (trace) {
                System.out.println("line1: " + ipAddress);
                System.out.println("line2: " + url);
            }
            StringTokenizer urlSt = new StringTokenizer(url, "//");
            int urlTokens = urlSt.countTokens();
            String aux1 = urlSt.nextToken();
            if (urlTokens > 1) {
                aux1 = urlSt.nextToken();
            }
            StringTokenizer aux1St = new StringTokenizer(aux1, ":");
            int aux1Tokens = aux1St.countTokens();
            String host = aux1St.nextToken();
            String port = "80";
            if (aux1Tokens > 1) {
                aux1 = aux1St.nextToken();
                StringTokenizer portSt = new StringTokenizer(aux1, "/");
                port = portSt.nextToken();
            }

	    if (trace) {
	        System.out.println("IP Address: " + ipAddress);
	        System.out.println("Host: " + host);
	        System.out.println("Port: " + port);
            }


            /* Remove the entry */
            //In case of error, we don't do anything, since the most likely cause
            // is that the entry was already removed. If the entry to remove does
            // not exist, we can consider the result correct.
            String command = null;
            Runtime rt = Runtime.getRuntime();
            Process ipTables = null;
            int result = -1;

	    command = "/sbin/iptables -D OUT_NETWORK -s " + ipAddress + " -d " +
                      host + " -p tcp --dport " + port + " -j AUTH_IP";
            ipTables = rt.exec(command);
            result = ipTables.waitFor();
            if (result != 0) {
                if (trace) {
                    System.out.println("Entry to remove in OUT_NETWORK does not exist");
                }
            }

            command = "/sbin/iptables -t nat -D WEB_REDIRECT -s " +  ipAddress +
                      " -d " + host + " -p tcp --dport " + port + " -j RETURN";
            ipTables = rt.exec(command);
            result = ipTables.waitFor();
            if (result != 0) {
                if (trace) {
                    System.out.println("Entry to remove in WEB_REDIRECT does not exist");
                }
            }
        }
    }


    private static void parseTraceArg(String[] args)
    {
        // The trace argument must be the first one.
        // This is to save execution time
        // If -t is present just after the program name, traces will be output

        if (args.length >= 1)
        {
            if (args[0].equals("-t"))
            {
                trace = true;
            }
        }
    }
}
