#!/bin/sh
# -----------------------------------------------------------------------------
# Start/Stop Script for the CATALINA Server
#
# Environment Variable Prequisites
#
#   JAVA_HOME       Must point at your Java Development Kit installation.
#
# $Id: catalina.sh,v 1.28 2002/05/20 19:11:57 pluby Exp $
# -----------------------------------------------------------------------------
# Modified by Ana Sanz Merino [University of California Berkeley, 2003]
# -----------------------------------------------------------------------------

# resolve links - $0 may be a softlink
PRG="$0"

while [ -h "$PRG" ]; do
  ls=`ls -ld "$PRG"`
  link=`expr "$ls" : '.*-> \(.*\)$'`
  if expr "$link" : '.*/.*' > /dev/null; then
    PRG="$link"
  else
    PRG=`dirname "$PRG"`/"$link"
  fi
done

# Get standard environment variables
PRGDIR=`dirname "$PRG"`
if [ -r "$PRGDIR"/setenv.sh ]; then
  . "$PRGDIR"/setenv.sh
fi

# Make sure prerequisite environment variables are set
if [ -z "$JAVA_HOME" ]; then
  echo "The JAVA_HOME environment variable is not defined"
  echo "This environment variable is needed to run this program"
  exit 1
fi

# Execute the Tomcat launcher
exec nice --adjustment=20 "$JAVA_HOME"/bin/java -Xms200m -Xmx200m -classpath "$PRGDIR" -Dcom.sun.launcher.executableName="$0" com.sun.jwsdp.launcher.TomcatExecutable "$@"
