import javax.servlet.*;
import javax.servlet.http.*;
import java.io.PrintWriter;
import com.sun.liberty.ProviderDescriptorFactory;
import com.sun.liberty.ProviderDescriptor;


/**
 * @author Ana Sanz Merino
 * @version $Revision: 1.1.1.1 $
 */

/**
 * Servlet filter which forwards requests to local Service Provider.
 */

public class AuthnFilter implements Filter {
    ProviderDescriptorFactory dir;
    ProviderDescriptor local;
    String localSoapEndPointStr;
    FilterConfig config;

    public void init(FilterConfig config) {
	this.config = config;
    }

    public void destroy() {}

    public void doFilter(ServletRequest request, ServletResponse response,
	    FilterChain chain) throws java.io.IOException, ServletException {

	if (!(request instanceof HttpServletRequest)) {
	    /*
	     * This filter relies on the HttpSession to maintain user
	     * session state, so it won't work with non-HTTP requests.
	     */
	    chain.doFilter(request, response);
	    return;
	}

        if (Config.debug) {
            System.err.println("AuthnFilter: Entering doFilter at: " +
                               new java.util.Date().getTime());
        }

        String redirectDest = null;
        HttpServletRequest req = (HttpServletRequest) request; 
        if (req.getHeader("SOAPAction") == null) {
            if (Config.debug) { System.err.println("ANP web-browser profile"); }

            String url = req.getRequestURL().toString();
            if (Config.debug) { System.err.println("Requested URL: " + url);}

            redirectDest = Config.localServiceProviderApp + Config.localServiceProviderMainPage;
        } else {
            if (Config.debug) { System.err.println("ANP web-client profile"); }

            //if (localSoapEndPointStr == null) {
            //    try {
            //        dir = ProviderDescriptorFactory.getInstance();
            //        local = dir.findLocal();
            //        localSoapEndPointStr = local.getSoapEndpoint().toString();
            //        if (Config.debug) {
            //            System.err.println("Local SP SOAP end point: " + localSoapEndPointStr);
            //        }
            //    } catch (Exception e) {
            //        e.printStackTrace();
            //    }
            //}
            //redirectDest = localSoapEndPointStr;
            redirectDest = "http://vancouver.cs.berkeley.edu:8080/Sahara_SSO_sp/soap";
        }

	/* Forward request to local Service Provider. */
	if (Config.debug) {
            System.err.println("AuthnFilter: Forwarding to local Service Provider.");
	}

        try {
            HttpServletResponse resp = (HttpServletResponse) response;
            resp.sendRedirect(redirectDest);
            if (Config.debug) {
                System.err.println("AuthnFilter: Sent redirect at: " +
                                   new java.util.Date().getTime());
            }
            //resp.sendRedirect("http://vancouver.CS.berkeley.edu/index.html");
            
            //ServletContext ctx = config.getServletContext();
            //RequestDispatcher disp;
            //disp = ctx.getRequestDispatcher("/index.html");
            //disp.forward(req, resp);

//            PrintWriter out = resp.getWriter();
//            out.println("<HEAD> <META HTTP-EQUIV=\"Expires\" CONTENT=\"-1\"> <META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\"> <META HTTP-EQUIV=\"Cache-Control\" CONTENT=\"no-cache\"> <META HTTP-EQUIV=\"Refresh\" CONTENT=\"0; URL=http://vancouver.CS.berkeley.edu:8080/Sahara_SSO_sp/Sahara_SSO_main.html\"> </HEAD>");

            //out.println("<HEAD> <META HTTP-EQUIV=\"Expires\" CONTENT=\"Mon, 06 Jan 1990 00:00:01 GMT\"> <META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\"> <META HTTP-EQUIV=\"Cache-Control\" CONTENT=\"no-cache\"> <META HTTP-EQUIV=\"Refresh\" CONTENT=\"0; URL=http://vancouver.CS.berkeley.edu:8080/Sahara_SSO_sp/Sahara_SSO_main.html\"> </HEAD>");
            //out.println("<HEAD> <META HTTP-EQUIV=\"Expires\" CONTENT=\"Mon, 06 Jan 1990 00:00:01 GMT\"> <META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\"> <META HTTP-EQUIV=\"Cache-Control\" CONTENT=\"no-cache\"> <META HTTP-EQUIV=\"Refresh\" CONTENT=\"0; URL=http://vancouver.CS.berkeley.edu/usage/index.html\"> </HEAD>");
        }
        catch (Exception e) {
            throw new ServletException("Redirection to local Service Provider failed", e);
        }

	return;
    }
}
