import java.util.Properties;

/**
 * Config parameters for the system.
 * Typically initialized by ConfigServlet from parameters listed in the
 * web-app deployment descriptor retrieved via ServletContext.
 *
 * See comments in the default deployment descriptor for further information
 * on these parameters.  Documentation is there to avoid duplication and
 * since the information there is visible at deployment time.
 */
public class Config {
    public static String localServiceProviderApp;
    public static String localServiceProviderMainPage;
    public static boolean debug;


    /* Default init */
    static {
	localServiceProviderApp = "http://localhost:8080/Sahara_SSO_sp";
        localServiceProviderMainPage = "/Sahara_SSO_main.html";
	debug = false;
    }

    /**
     * Initialize the parameters using the given properties, which should
     * have names corresponding to the field names of this object.
     */
    public static void init(Properties props) {
	localServiceProviderApp = props.getProperty("localServiceProviderApp");
	localServiceProviderMainPage = props.getProperty("localServiceProviderMainPage");
	debug = Boolean.valueOf(props.getProperty("debug")).booleanValue();
    }
}
