/*
 * $Id: LibertyIDPEntry.java,v 1.3.2.1 2002/09/17 01:52:23 jsergent Exp $
 * LibertyIDPEntry.java
 *
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.experimentalstuff.com/Technologies/IPL/download.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2002 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 */

package com.sun.liberty;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * Data bindings for lib:IDPEntry element.  For LECP.  Not yet used.
 * @author Jonathan Sergent
 * @version $Revision: 1.3.2.1 $
 */
public class LibertyIDPEntry extends XMLElement implements LibertyElement {
    private String providerID = null;
    private String providerName = null;
    private String loc = null;

    public Element getElement(Document doc) {
	Element l = doc.createElementNS(LIB_NS_URI, "lib:IDPEntry");
	addChildrenTo(l);
	return l;
    }

    protected void addChildrenTo(Element l) {
	appendNewChildNSWithText(l, LIB_NS_URI, "lib:ProviderID", providerID);
	appendNewChildNSWithText(l, LIB_NS_URI, "lib:ProviderName", providerName);
	appendNewChildNSWithText(l, LIB_NS_URI, "lib:Loc", loc);
    }

    public String getProviderID() {
	return providerID;
    }

    public void setProviderID(String value) {
	providerID = value;
    }

    public String getProviderName() {
	return providerName;
    }

    public void setProviderName(String value) {
	providerName = value;
    }

    public String getLoc() {
	return loc;
    }

    public void setLoc(String value) {
	loc = value;
    }
}
