/*
 * $Id: SPDescriptor.java,v 1.3.2.1 2002/09/17 01:52:26 jsergent Exp $
 * SPDescriptor.java
 *
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.experimentalstuff.com/Technologies/IPL/download.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2002 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 */

package com.sun.liberty;
import java.net.URL;

/**
 * Stores provisioning information for a Liberty service provider.
 * XXX: Should probably eventually provide interfaces for setting stuff, too.
 *
 * @author Jonathan Sergent
 * @version $Revision: 1.3.2.1 $
 */
public interface SPDescriptor extends ProviderDescriptor {
    /**
     * Gets the assertion consumer URL for single sign-on.
     *
     * @return	The URL used for user-agent-based Single Sign-on Protocol
     * 		profiles.
     */
    public URL getAssertionConsumerURL();

    /**
     * Gets the identifier of the profile to be used for the Federation 
     * Termination Notification Protocol.
     *
     * @return	The Federation Termination Notification Protocol profile that
     * 		the Identity Provider should use when communicating with the
     * 		Service Provider.
     */
    public LibertyProfile getFederationTerminationProtocolProfile();

    /**
     * Gets the identifier of the profile to be used for the Single Logout
     * Protocol.
     *
     * @return	The Single Logout Protocol profile that the Identity Provider
     * 		should use when communicating with the Service Provider.
     */
    public LibertyProfile getSingleLogoutProtocolProfile();

    /**
     * Determines whether the service provider intends to sign all of its
     * authentication requests.
     *
     * @return	Specifies whether the Service Provider will always sign
     * 		authentication requests it sends to the Identity Provider.
     */
    public boolean getAuthnRequestsSigned();
}
