/*
 * $Id: SAMLAction.java,v 1.5.2.1 2002/09/17 01:52:29 jsergent Exp $
 * SAMLAction.java
 *
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.experimentalstuff.com/Technologies/IPL/download.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2002 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 */

package com.sun.liberty.saml;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * Data bindings for saml:Action element.
 *
 * @author Jonathan Sergent
 * @version $Revision: 1.5.2.1 $
 */

public class SAMLAction extends SAMLElement {
    String namespace = null;
    String action = "";

    
    public void parse(Element e) {
	setNamespace(e.getAttributeNS(null, "Namespace"));
	setAction(e.getFirstChild().getNodeValue());
    }

    public Element getElement(Document doc) {
	Element s = doc.createElementNS(SAML_NS_URI, "saml:Action");
	addAttributesTo(s);
	addChildrenTo(s);
	return s;
    }

    protected void addAttributesTo(Element s) {
	if (namespace != null) {
	    s.setAttributeNS(null, "Namespace", namespace);
	}
    }

    protected void addChildrenTo(Element s) {
	s.appendChild(s.getOwnerDocument().createTextNode(action));
    }

    /**
     * Returns the namespace value.
     * @return the namespace
     */
    public String getNamespace() {
	return namespace;
    }

    /** 
     * Sets or clears the namespace value.
     * @param value the new value, or null
     */
    public void setNamespace(String value) {
	namespace = value;
    }

    /**
     * Returns the action value.
     * @return the action
     */
    public String getAction() {
	return action;
    }

    /**
     * Sets or clears the action value.
     * @param value the action, or null
     */
    public void setAction(String value) {
	action = value;
    }
}
