/*
 * $Id: SAMLAttribute.java,v 1.6.2.1 2002/09/17 01:52:29 jsergent Exp $
 * SAMLAttribute.java
 *
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.experimentalstuff.com/Technologies/IPL/download.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2002 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 */

package com.sun.liberty.saml;
import com.sun.liberty.DummyXMLElement;
import java.util.List;
import java.util.LinkedList;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * Data bindings for saml:Attribute element.
 *
 * @author Jonathan Sergent
 * @version $Revision: 1.6.2.1 $
 */

public class SAMLAttribute extends SAMLAttributeDesignator {
    List attributeValues = null;


    public void parse(Element e) {
	super.parse(e);
	NodeList list = e.getChildNodes();
	for (int i = 0; i < list.getLength(); i++) {
	    if (list.item(i) instanceof org.w3c.dom.Text) { continue; }
	    Element child = (Element) list.item(i);
	    DummyXMLElement c = new DummyXMLElement(child);
	    List set = getAttributeValues();
	    if (set == null) {
		set = new LinkedList();
	    }
	    set.add(c);
	    setAttributeValues(set);
	}
    }
	    
    public Element getElement(Document doc) {
	Element a = doc.createElementNS(SAML_NS_URI, "saml:Attribute");
	addAttributesTo(a);
	addChildrenTo(a);
	return a;
    }

    protected void addAttributesTo(Element a) {
	super.addAttributesTo(a);
    }

    protected void addChildrenTo(Element a) {
	iterateAddChildren(a, attributeValues);
    }


    /**
     * Returns a List of XMLElement objects containing attribute values.
     * @return the list, or null if not present
     */
    public List getAttributeValues() {
	return attributeValues;
    }

    /**
     * Sets or clears the attribute values.  The list must contain
     * XMLElement objects.
     * @param value the list, or null
     */
    public void setAttributeValues(List set) {
	attributeValues = set;
    }
}
