package ucb.eecs.sahara.sso.anp;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


/**
 * @author Ana Sanz Merino
 * @version $Revision: 1.1.1.1 $
 */

public interface ANPAuthnContQueryProcessor {
    /**
     * Processes ANPAuthnContQueries.  Fills in an ANPAuthnQueryProcResult object 
     * with information about the processing result:
     *     - ANP failureCode, if some protocol error is found
     *     - Result of authenticating the user (Success/Failure)
     *     - Redirect URL, if redirection to another server is required
     * Returns an ANPRequestProcessorAction indicating what the servlet
     * should do with the response.
     *
     * @param request: The ANPAuthnContQuery received
     * @param procResult: An empty ANPAuthnQueryProcResult object to be used in
     *                    responding to the request.
     * @return: An ANPRequestProcessorAction indicating what to do next:
     *          - FAILED if an exception while processing the query occurs
     *          - RETURN_RESPONSE if no exception occurs
     */
    public ANPRequestProcessorAction process(HttpServletRequest httpReq,
	 				     HttpServletResponse httpResp,
					     ANPAuthnContQuery request,
                                             ANPAuthnQueryProcResult procResult)
            throws Exception;
}

