package ucb.eecs.sahara.sso.anp;

import com.sun.liberty.XMLElement;
import java.util.List;
import java.util.LinkedList;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * @author Ana Sanz Merino
 * @version $Revision: 1.1.1.1 $
 */
public class ANPAuthnMethod extends XMLElement implements ANPElement {
    private String authnMethodID = null;
    private List userInfoDesignators = null;
    private List serviceIDReferences = null;

    public void parse(Element e) {
        NodeList list = e.getChildNodes();
        for (int j = 0; j < list.getLength(); j++) {
            if (list.item(j) instanceof org.w3c.dom.Text) { continue; }
            Element child = (Element) list.item(j);
            if (isElement(child, ANP_NS_URI, "AuthnMethodID")) {
                setAuthnMethodID(child.getFirstChild().getNodeValue());
            } else if (isElement(child, ANP_NS_URI, "UserInfoDesignator")) {
                ANPUserInfoDesignator c = new ANPUserInfoDesignator();
                c.parse(child);
                List set = getUserInfoDesignators();
                if (set == null) {
                    set = new LinkedList();
                }
                set.add(c);
                setUserInfoDesignators(set);
            } else if (isElement(child, ANP_NS_URI, "ServiceIDReference")) {
                List set = getServiceIDReferences();
                if (set == null) {
                    set = new LinkedList();
                }
                set.add(child.getFirstChild().getNodeValue());
                setServiceIDReferences(set);
            }
        }
    }

    public Element getElement(Document doc) {
	Element l = doc.createElementNS(ANP_NS_URI, "anp:AuthnMethod");
	addChildrenTo(l);
	return l;
    }

    protected void addChildrenTo(Element s) {
	appendNewChildNSWithText(s, ANP_NS_URI,
            ANP_NS_ID + ":AuthnMethodID", authnMethodID);
        iterateAddChildren(s, userInfoDesignators);
        iterateAddChildren(s, serviceIDReferences);
    }

    public String getAuthnMethodID() {
	return authnMethodID;
    }

    public void setAuthnMethodID(String value) {
	authnMethodID = value;
    }

    public List getUserInfoDesignators() {
	return userInfoDesignators;
    }

    public void setUserInfoDesignators(List value) {
	userInfoDesignators = value;
    }

    public List getServiceIDReferences() {
	return serviceIDReferences;
    }

    public void setServiceIDReferences(List value) {
	serviceIDReferences = value;
    }
}
