package ucb.eecs.sahara.sso.anp;

import com.sun.liberty.XMLElement;
import java.util.List;
import java.util.LinkedList;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * @author Ana Sanz Merino
 * @version $Revision: 1.1.1.1 $
 */

public class ANPIDPList extends XMLElement implements ANPElement {
    private List idpNames = null;
    private List idpDomains = null;

    public void parse(Element e) {
        NodeList list = e.getChildNodes();
        for (int j = 0; j < list.getLength(); j++) {
            if (list.item(j) instanceof org.w3c.dom.Text) { continue; }
            Element child = (Element) list.item(j);
            if (isElement(child, ANP_NS_URI, "IDPName")) {
                List set = getIDPNames();
                if (set == null) {
                    set = new LinkedList();
                }
                set.add(child.getFirstChild().getNodeValue());
                setIDPNames(set);
            } else if (isElement(child, ANP_NS_URI, "IDPDomain")) {
                List set = getIDPDomains();
                if (set == null) {
                    set = new LinkedList();
                }
                set.add(child.getFirstChild().getNodeValue());
                setIDPDomains(set);
            }
        }
    }

    public Element getElement(Document doc) {
	Element l = doc.createElementNS(ANP_NS_URI, ANP_NS_ID + ":IDPList");
	addChildrenTo(l);
	return l;
    }

    protected void addChildrenTo(Element s) {
        iterateAddNewChildrenNSWithText(s, ANP_NS_URI, ANP_NS_ID + ":IDPName",
                                 idpNames);
        iterateAddNewChildrenNSWithText(s, ANP_NS_URI, ANP_NS_ID + ":IDPDomain",
                                 idpDomains);
    }

    public List getIDPNames() {
	return idpNames;
    }

    public void setIDPNames(List value) {
	idpNames = value;
    }

    public List getIDPDomains() {
	return idpDomains;
    }

    public void setIDPDomains(List value) {
	idpDomains = value;
    }
}
