package ucb.eecs.sahara.sso.anp;

import com.sun.liberty.XMLElement;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * @author Ana Sanz Merino
 * @version $Revision: 1.1.1.1 $
 */
public class ANPRedirectInfo extends XMLElement implements ANPElement {
    private String redirectURL = null;
    private boolean sessionInfoRequired = false;

    public void parse(Element e) {
        NodeList list = e.getChildNodes();
        for (int j = 0; j < list.getLength(); j++) {
            if (list.item(j) instanceof org.w3c.dom.Text) { continue; }
            Element child = (Element) list.item(j);
            if (isElement(child, ANP_NS_URI, "RedirectURL")) {
                setRedirectURL(child.getFirstChild().getNodeValue());
            } else if (isElement(child, ANP_NS_URI, "SessionInfoRequired")) {
		String s = child.getFirstChild().getNodeValue();
                setSessionInfoRequired(Boolean.valueOf(s).booleanValue());
            }
        }
    }

    public Element getElement(Document doc) {
	Element l = doc.createElementNS(ANP_NS_URI, "anp:RedirectInfo");
	addChildrenTo(l);
	return l;
    }

    protected void addChildrenTo(Element s) {
	appendNewChildNSWithText(s, ANP_NS_URI,
            ANP_NS_ID + ":RedirectURL", redirectURL);
	appendNewChildNSWithText(s, ANP_NS_URI,
            ANP_NS_ID + ":SessionInfoRequired",
	    new Boolean(sessionInfoRequired).toString());
    }

    public String getRedirectURL() {
	return redirectURL;
    }

    public void setRedirectURL(String value) {
	redirectURL = value;
    }

    public boolean getSessionInfoRequired() {
	return sessionInfoRequired;
    }

    public void setSessionInfoRequired(boolean value) {
	sessionInfoRequired = value;
    }
}
