package ucb.eecs.sahara.sso.anp;

import com.sun.liberty.XMLElement;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * @author Ana Sanz Merino
 * @version $Revision: 1.1.1.1 $
 */

public class ANPService extends XMLElement implements ANPElement {
    private String serviceID = null;
    private String serviceDescription = null;

    public void parse(Element e) {
        NodeList list = e.getChildNodes();
        for (int j = 0; j < list.getLength(); j++) {
            if (list.item(j) instanceof org.w3c.dom.Text) { continue; }
            Element child = (Element) list.item(j);
            if (isElement(child, ANP_NS_URI, "ServiceID")) {
                setServiceID(child.getFirstChild().getNodeValue());
            } else if (isElement(child, ANP_NS_URI, "ServiceDescription")) {
                setServiceDescription(child.getFirstChild().getNodeValue());
            }
        }
    }

    public Element getElement(Document doc) {
	Element l = doc.createElementNS(ANP_NS_URI, "anp:Service");
	addChildrenTo(l);
	return l;
    }

    protected void addChildrenTo(Element s) {
	appendNewChildNSWithText(s, ANP_NS_URI,
            ANP_NS_ID + ":ServiceID", serviceID);
	appendNewChildNSWithText(s, ANP_NS_URI,
            ANP_NS_ID + ":ServiceDescription", serviceDescription);
    }

    public String getServiceID() {
	return serviceID;
    }

    public void setServiceID(String value) {
	serviceID = value;
    }

    public String getServiceDescription() {
	return serviceDescription;
    }

    public void setServiceDescription(String value) {
	serviceDescription = value;
    }
}
