package ucb.eecs.sahara.sso.authn;

import com.sun.liberty.Config;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import ucb.eecs.sahara.sso.authn.SimpleRadiusAuthenticator;


/**
 * @author Ana Sanz Merino
 * @version $Revision: 1.1.1.1 $
 */

public class SessionRadiusAuthenticator {

    public static void sessionCleanUp(HttpServletRequest httpReq) {
        HttpSession ses = httpReq.getSession(true);
        if (ses.getAttribute("radius.authenticated") != null) {
            ses.removeAttribute("radius.authenticated");
        }
    }


    public static AuthenticatorResult authenticate(HttpServletRequest httpReq,
                                                   final String userName,
                                                   final String userPassword)
		  throws Exception
    {
	AuthenticatorResult authn = null;
	authn = SimpleRadiusAuthenticator.authenticate(userName, userPassword);
	if (authn == AuthenticatorResult.AUTHN_SUCCESS) {
            HttpSession ses = httpReq.getSession(true);
            ses.setAttribute("radius.authenticated", "true");
 	}
	return authn;
    }
}
